﻿// <auto-generated />
using System;
using HealthyHoleApplication.Models;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace HealthyHoleApplication.Migrations
{
    [DbContext(typeof(HealthyHoleContext))]
    [Migration("20211105042220_Initial")]
    partial class Initial
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "5.0.11");

            modelBuilder.Entity("HealthyHoleApplication.Models.Employee", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("TEXT")
                        .HasColumnName("id");

                    b.Property<string>("MiddleName")
                        .HasColumnType("TEXT")
                        .HasColumnName("middle_name");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("TEXT")
                        .HasColumnName("name");

                    b.Property<long>("PositionId")
                        .HasColumnType("INTEGER")
                        .HasColumnName("position_id");

                    b.Property<string>("Surname")
                        .IsRequired()
                        .HasColumnType("TEXT")
                        .HasColumnName("surname");

                    b.HasKey("Id");

                    b.HasIndex("PositionId");

                    b.ToTable("employees");
                });

            modelBuilder.Entity("HealthyHoleApplication.Models.Position", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("INTEGER")
                        .HasColumnName("id");

                    b.Property<string>("PositionName")
                        .HasColumnType("TEXT")
                        .HasColumnName("position_name");

                    b.HasKey("Id");

                    b.ToTable("positions");
                });

            modelBuilder.Entity("HealthyHoleApplication.Models.Shift", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("INTEGER")
                        .HasColumnName("id");

                    b.Property<Guid>("EmployeeId")
                        .HasColumnType("TEXT")
                        .HasColumnName("employee_id");

                    b.Property<DateTime>("EndTime")
                        .HasColumnType("TEXT")
                        .HasColumnName("end_time");

                    b.Property<DateTime>("HoursWorked")
                        .HasColumnType("TEXT")
                        .HasColumnName("hours_worked");

                    b.Property<long?>("PositionId")
                        .HasColumnType("INTEGER");

                    b.Property<DateTime>("StartTime")
                        .HasColumnType("TEXT")
                        .HasColumnName("start_time");

                    b.HasKey("Id");

                    b.HasIndex("EmployeeId");

                    b.HasIndex("PositionId");

                    b.ToTable("shifts");
                });

            modelBuilder.Entity("HealthyHoleApplication.Models.Employee", b =>
                {
                    b.HasOne("HealthyHoleApplication.Models.Position", "Position")
                        .WithMany()
                        .HasForeignKey("PositionId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Position");
                });

            modelBuilder.Entity("HealthyHoleApplication.Models.Shift", b =>
                {
                    b.HasOne("HealthyHoleApplication.Models.Employee", "Employee")
                        .WithMany("Shifts")
                        .HasForeignKey("EmployeeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("HealthyHoleApplication.Models.Position", null)
                        .WithMany("Shifts")
                        .HasForeignKey("PositionId");

                    b.Navigation("Employee");
                });

            modelBuilder.Entity("HealthyHoleApplication.Models.Employee", b =>
                {
                    b.Navigation("Shifts");
                });

            modelBuilder.Entity("HealthyHoleApplication.Models.Position", b =>
                {
                    b.Navigation("Shifts");
                });
#pragma warning restore 612, 618
        }
    }
}
